import { defineStore, storeToRefs } from 'pinia'
import { BasicColumns, ColumnInfo, ColumnName, Columns, DetailsColumns, MoveColumns } from '../lib/columns'
import { ColumnSet } from '../lib/table'
import { TricksterInventory } from '../lib/trickster'

const _defaultColumn:(ColumnInfo| ColumnName)[] = [
  ...BasicColumns,
  ...MoveColumns,
  ...DetailsColumns,
]
export const useStore = defineStore('state', {
  state: ()=> {
    return {
      accounts: new Set() as Set<string>,
      invs: new Map() as Map<string,TricksterInventory>,
      activeTable: "none",
      screen: "default",
      columns: new ColumnSet(_defaultColumn),
      tags: new ColumnSet(),
    }
  }
})
export const useStoreRef = ()=>{return storeToRefs(useStore())};


